semigroupoids-6.0.1: Semigroupoids: Category sans id

Copyright | (C) 2011-2015 Edward Kmett
License | BSD-style (see the file LICENSE)
Maintainer | Edward Kmett <ekmett@gmail.com>
Stability | provisional
Portability | polykinds
Safe Haskell | Safe
Language | Haskell2010

Data.Isomorphism

Description

# Documentation

data Iso (k1 :: k -> k -> Type) (a :: k) (b :: k) Source #

Constructors

Iso |

Fields

- embed :: k1 a b
- project :: k1 b a

#### Instances

Instances details

Category k2 => Category (Iso k2 :: k1 -> k1 -> Type) Source # |
Instance details Defined in Data.Isomorphism Methods id :: forall (a :: k1). Iso k2 a a Source # (.) :: forall (b :: k1) (c :: k1) (a :: k1). Iso k2 b c -> Iso k2 a b -> Iso k2 a c Source #
Semigroupoid k2 => Groupoid (Iso k2 :: k1 -> k1 -> Type) Source # |
Instance details Defined in Data.Isomorphism Methods inv :: forall (a :: k1) (b :: k1). Iso k2 a b -> Iso k2 b a Source #
Semigroupoid k2 => Semigroupoid (Iso k2 :: k1 -> k1 -> Type) Source # |
Instance details Defined in Data.Isomorphism Methods o :: forall (j :: k1) (k10 :: k1) (i :: k1). Iso k2 j k10 -> Iso k2 i j -> Iso k2 i k10 Source #